#include<fstream>
using namespace std;
int prime(int a)
{
	int i;
	for(i=2;i*i<=a;i++)
	{
		if(a%i==0) return 0;
	}
	return 1;
}
int main()
{
	ifstream f1("BAI1_16.INP");
	ofstream f2("BAI1_16.OUT");
	int n;
	f1>>n;
	f1.close();
	int i=2;
	if(prime(n)==1) 
	{
		f2<<n;
		return 0;
	}
	for(i=2;i<=n;i++)
	{
		if(prime(i)==1)
		{
			while((n!=0)&&(n%i==0)) n/=i;
		}
		if(n==0) break;
	}
	f2<<i-1;
	f2.close();
	return 0;
}
